function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
import { ViewPlugin, logException, getTooltip } from '@codemirror/view';
import { cur, CompletionContext, applyCompletion } from "./completion.js";
import { completionConfig } from "./config.js";
import { completionState, setSelectedEffect, startCompletionEffect, closeCompletionEffect, setActiveEffect, State, ActiveSource, ActiveResult, getUserEvent } from "./state.js";

/// Returns a command that moves the completion selection forward or
/// backward by the given amount.
export function moveCompletionSelection(forward) {
  var by = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'option';
  return function (view) {
    var cState = view.state.field(completionState, false);
    if (!cState || !cState.open || Date.now() - cState.open.timestamp < view.state.facet(completionConfig).interactionDelay) {
      return false;
    }
    var step = 1,
      tooltip;
    if (by === 'page' && (tooltip = getTooltip(view, cState.open.tooltip))) {
      step = Math.max(2, Math.floor(tooltip.dom.offsetHeight / tooltip.dom.querySelector('li').offsetHeight) - 1);
    }
    var length = cState.open.options.length;
    var selected = cState.open.selected > -1 ? cState.open.selected + step * (forward ? 1 : -1) : forward ? 0 : length - 1;
    if (selected < 0) {
      selected = by === 'page' ? 0 : length - 1;
    } else if (selected >= length) {
      selected = by === 'page' ? length - 1 : 0;
    }
    view.dispatch({
      effects: setSelectedEffect.of(selected)
    });
    return true;
  };
}

/// Accept the current completion.
export var acceptCompletion = function acceptCompletion(view) {
  var cState = view.state.field(completionState, false);
  if (view.state.readOnly || !cState || !cState.open || cState.open.selected < 0 || Date.now() - cState.open.timestamp < view.state.facet(completionConfig).interactionDelay) {
    return false;
  }
  applyCompletion(view, cState.open.options[cState.open.selected]);
  return true;
};

/// Explicitly start autocompletion.
export var startCompletion = function startCompletion(view) {
  var cState = view.state.field(completionState, false);
  if (!cState) {
    return false;
  }
  view.dispatch({
    effects: startCompletionEffect.of(true)
  });
  return true;
};

/// Close the currently active completion.
export var closeCompletion = function closeCompletion(view) {
  var cState = view.state.field(completionState, false);
  if (!cState || !cState.active.some(function (a) {
    return a.state !== State.Inactive;
  })) {
    return false;
  }
  view.dispatch({
    effects: closeCompletionEffect.of(null)
  });
  return true;
};
var RunningQuery = /*#__PURE__*/_createClass(function RunningQuery(active, context) {
  _classCallCheck(this, RunningQuery);
  this.active = active;
  this.context = context;
  this.time = Date.now();
  this.updates = [];
  // Note that 'undefined' means 'not done yet', whereas 'null' means
  // 'query returned null'.
  this.done = undefined;
});
var DebounceTime = 50,
  MaxUpdateCount = 50,
  MinAbortTime = 1000;
var CompositionState = /*#__PURE__*/function (CompositionState) {
  CompositionState[CompositionState["None"] = 0] = "None";
  CompositionState[CompositionState["Started"] = 1] = "Started";
  CompositionState[CompositionState["Changed"] = 2] = "Changed";
  CompositionState[CompositionState["ChangedAndMoved"] = 3] = "ChangedAndMoved";
  return CompositionState;
}(CompositionState || {});
export var completionPlugin = ViewPlugin.fromClass( /*#__PURE__*/function () {
  function _class3(view) {
    _classCallCheck(this, _class3);
    this.view = view;
    this.debounceUpdate = -1;
    this.running = [];
    this.debounceAccept = -1;
    this.composing = CompositionState.None;
    var _iterator = _createForOfIteratorHelper(view.state.field(completionState).active),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var _active = _step.value;
        if (_active.state === State.Pending) {
          this.startQuery(_active);
        }
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  }
  _createClass(_class3, [{
    key: "update",
    value: function update(_update) {
      var _this = this;
      var cState = _update.state.field(completionState);
      if (!_update.selectionSet && !_update.docChanged && _update.startState.field(completionState) === cState) {
        return;
      }
      var doesReset = _update.transactions.some(function (tr) {
        return (tr.selection || tr.docChanged) && !getUserEvent(tr);
      });
      for (var i = 0; i < this.running.length; i++) {
        var query = this.running[i];
        if (doesReset || query.updates.length + _update.transactions.length > MaxUpdateCount && Date.now() - query.time > MinAbortTime) {
          var _iterator2 = _createForOfIteratorHelper(query.context.abortListeners),
            _step2;
          try {
            for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
              var handler = _step2.value;
              try {
                handler();
              } catch (e) {
                logException(this.view.state, e);
              }
            }
          } catch (err) {
            _iterator2.e(err);
          } finally {
            _iterator2.f();
          }
          query.context.abortListeners = null;
          this.running.splice(i--, 1);
        } else {
          var _query$updates;
          (_query$updates = query.updates).push.apply(_query$updates, _toConsumableArray(_update.transactions));
        }
      }
      if (this.debounceUpdate > -1) {
        clearTimeout(this.debounceUpdate);
      }
      this.debounceUpdate = cState.active.some(function (a) {
        return a.state === State.Pending && !_this.running.some(function (q) {
          return q.active.source === a.source;
        });
      }) ? setTimeout(function () {
        return _this.startUpdate();
      }, DebounceTime) : -1;
      if (this.composing !== CompositionState.None) {
        var _iterator3 = _createForOfIteratorHelper(_update.transactions),
          _step3;
        try {
          for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
            var tr = _step3.value;
            if (getUserEvent(tr) === 'input') {
              this.composing = CompositionState.Changed;
            } else if (this.composing === CompositionState.Changed && tr.selection) {
              this.composing = CompositionState.ChangedAndMoved;
            }
          }
        } catch (err) {
          _iterator3.e(err);
        } finally {
          _iterator3.f();
        }
      }
    }
  }, {
    key: "startUpdate",
    value: function startUpdate() {
      var _this2 = this;
      this.debounceUpdate = -1;
      var state = this.view.state,
        cState = state.field(completionState);
      var _iterator4 = _createForOfIteratorHelper(cState.active),
        _step4;
      try {
        var _loop = function _loop() {
          var active = _step4.value;
          if (active.state === State.Pending && !_this2.running.some(function (r) {
            return r.active.source === active.source;
          })) {
            _this2.startQuery(active);
          }
        };
        for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
          _loop();
        }
      } catch (err) {
        _iterator4.e(err);
      } finally {
        _iterator4.f();
      }
    }
  }, {
    key: "startQuery",
    value: function startQuery(active) {
      var _this3 = this;
      var state = this.view.state,
        pos = cur(state);
      var context = new CompletionContext(state, pos, active.explicitPos === pos);
      var pending = new RunningQuery(active, context);
      this.running.push(pending);
      Promise.resolve(active.source(context)).then(function (result) {
        if (!pending.context.aborted) {
          pending.done = result || null;
          return _this3.scheduleAccept();
        }
        return undefined;
      }, function (err) {
        _this3.view.dispatch({
          effects: closeCompletionEffect.of(null)
        });
        logException(_this3.view.state, err);
        return undefined;
      }).catch(console.error);
    }
  }, {
    key: "scheduleAccept",
    value: function scheduleAccept() {
      var _this4 = this;
      if (this.running.every(function (q) {
        return q.done !== undefined;
      })) {
        this.accept();
      } else if (this.debounceAccept < 0) {
        this.debounceAccept = setTimeout(function () {
          return _this4.accept();
        }, DebounceTime);
      }
    }

    // For each finished query in this.running, try to create a result
    // or, if appropriate, restart the query.
  }, {
    key: "accept",
    value: function accept() {
      var _this5 = this;
      if (this.debounceAccept > -1) {
        clearTimeout(this.debounceAccept);
      }
      this.debounceAccept = -1;
      var updated = [];
      var conf = this.view.state.facet(completionConfig);
      var _loop2 = function _loop2(_i) {
          var query = _this5.running[_i];
          if (query.done === undefined) {
            i = _i;
            return 0; // continue
          }
          _this5.running.splice(_i--, 1);
          if (query.done) {
            var _query$done$to;
            var _active2 = new ActiveResult(query.active.source, query.active.explicitPos, query.done, query.done.from, (_query$done$to = query.done.to) !== null && _query$done$to !== void 0 ? _query$done$to : cur(query.updates.length ? query.updates[0].startState : _this5.view.state));
            // Replay the transactions that happened since the start of
            // the request and see if that preserves the result
            var _iterator5 = _createForOfIteratorHelper(query.updates),
              _step5;
            try {
              for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
                var tr = _step5.value;
                _active2 = _active2.update(tr, conf);
              }
            } catch (err) {
              _iterator5.e(err);
            } finally {
              _iterator5.f();
            }
            if (_active2.hasResult()) {
              updated.push(_active2);
              i = _i;
              return 0; // continue
            }
          }
          var current = _this5.view.state.field(completionState).active.find(function (a) {
            return a.source === query.active.source;
          });
          if (current && current.state === State.Pending) {
            if (query.done === null) {
              // Explicitly failed. Should clear the pending status if it
              // hasn't been re-set in the meantime.
              var _active3 = new ActiveSource(query.active.source, State.Inactive);
              var _iterator6 = _createForOfIteratorHelper(query.updates),
                _step6;
              try {
                for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
                  var _tr = _step6.value;
                  _active3 = _active3.update(_tr, conf);
                }
              } catch (err) {
                _iterator6.e(err);
              } finally {
                _iterator6.f();
              }
              if (_active3.state !== State.Pending) {
                updated.push(_active3);
              }
            } else {
              // Cleared by subsequent transactions. Restart.
              _this5.startQuery(current);
            }
          }
          i = _i;
        },
        _ret;
      for (var i = 0; i < this.running.length; i++) {
        _ret = _loop2(i);
        if (_ret === 0) continue;
      }
      if (updated.length) {
        this.view.dispatch({
          effects: setActiveEffect.of(updated)
        });
      }
    }
  }]);
  return _class3;
}(), {
  eventHandlers: {
    blur: function blur() {
      var state = this.view.state.field(completionState, false);
      if (state && state.tooltip && this.view.state.facet(completionConfig).closeOnBlur) {
        this.view.dispatch({
          effects: closeCompletionEffect.of(null)
        });
      }
    },
    compositionstart: function compositionstart() {
      this.composing = CompositionState.Started;
    },
    compositionend: function compositionend() {
      var _this6 = this;
      if (this.composing === CompositionState.ChangedAndMoved) {
        // Safari fires compositionend events synchronously, possibly
        // from inside an update, so dispatch asynchronously to avoid reentrancy
        setTimeout(function () {
          return _this6.view.dispatch({
            effects: startCompletionEffect.of(false)
          });
        }, 20);
      }
      this.composing = CompositionState.None;
    }
  }
});